#!/usr/bin/perl
############################################################################
#                                                                          #
# FL_ADMIN                          Version 1.0                            #
# Written by Puppet Master          pmaster@ravensclaw.com                 #
# Created 3/02/99                   Last Modified 03/03/99                 #
#                                                                          #
# Purpose: To delete entries from the linkdb database used by FreeLinks    #
#                                                                          #
# Copyright 1999 Puppet Master.  This script was written to accompany      #
# the FreeLinks script also written by The Puppet Master.                  #
# You are granted a license to use this scripts, under the GNU public      #
# license.  You are authorized to make changes to the script to meet your  #
# needs, however this copyright notice must remain intact.                 #
#                                                                          #
############################################################################
# Define configuration constants                                           #
############################################################################

# $cgi_url is the location of where this script resides including the name.
$cgi_url ="http://www.ravensclaw.com/~pmaster/cgi-bin/fl_admin.cgi";

# Username & Password are set to your name and password to prevent just
# anyone deleting entries from the database.  A better form of security
# may be created in the future, but for now this should work.

$username = 'pmaster';
$password = 'testpass';

# $basedir is the path to the linkdb file.
$basedir = '/home/pmaster/public_html/freelink';

############################################################################
# WARNING: DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU   #
# ARE DOING!!!                                                             #
############################################################################

require 'parsform.pl';

$linkdb = "linkdb";
$logfile = "log.txt";
$catfile = "sections.txt";

$TMP1 = 'temp1';
$TMP2 = 'temp2';

if ($ENV{'QUERY_STRING'} ne '') {
	$command = "$ENV{'QUERY_STRING'}";
}
else {
	&parse_form;
}

print "Content-type: text/html\n\n";

# Delete Entry!

if ($command eq 'delete') {
	$i=0;
	if (!open(DB,"$basedir/$linkdb")) {
		print "Can't Open LinkDB(1) - Cause: $!";
		exit;
	}
	@lines = <DB>;
	close(DB);
	foreach $line (@lines) {
		$i++;
	}
	if ($i eq "0") {
		&no_data;
	}
   print "<html><head><title>Delete Entry</title></head>\n";
   print "<body><center><h1>Delete Entry </h1></center>\n";
	print "There Are <b>$i</b> Links In The Database<br>\n";
   print "Check the box below on the links you wish to delete\n";
   print "<hr>\n";
   print "<center>\n";
   print "<form method=\"POST\" action=\"$cgi_url\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"remove\">\n";
	print "Username: <input type=text name=\"username\"> -- \n";
	print "Password: <input type=password name=\"password\">\n";
   print "<table border>\n";
   print "<tr>\n"; 
   print "<th>Delete</th><th>Category</th><th>Site Name</th><th>URL</th><th>Description</th>\n";   
	if(!open(DB,"$basedir/$linkdb")) {
		print "Can't Open LinkDB(2) - Cause: $!";
		exit;
	}
   @lines = <DB>;
   close(DB);

	$count = 0;
   foreach $line (@lines) {
		$count++;
		($section,$site,$url,$desc) = (split(/\|\|/,$line));
		chop($desc);
		$l = length($desc);
		if ($l eq "0") {
			$desc = "<b><font color=\"RED\">NO DESCRIPTION ENTERED</font></b>";
		}
      print "<tr>\n";
      print "<td align=center><input type=checkbox name=\"lineno\" value=\"$url\"></td><td align=center>$section</td><td align=center>$site</td><td align=center>$url</td><td align=center>$desc</td>\n";
      print "</tr>\n";
   }
   print "</table>\n";
   print "<center><p>\n";
   print "<input type=submit value=\"Delete\"> <input type=reset>\n";
   print "</form>\n";
	print "<p><a href=\"$cgi_url\">RETURN</a>\n";
	print "&nbsp;&nbsp<a href=\"$cgi_url?delete\">REFRESH</a>\n";
   print "</body></html>\n";
}

elsif ($command eq 'category') {
	if(!open(CAT,"$basedir/$catfile")) {
		print "Can't Open Catalog File(1) - Cause: $!";
		exit;
	}
	@CATEGORY = <CAT>;
	close(CAT);
	$i=0;
	foreach $line(@CATEGORY) {
		$i++;
	}


   print "<html><head><title>Edit Categories</title></head>\n";
   print "<body><center><h1>Edit Categories</h1></center>\n";
	print "There Are <b>$i</b> Categories Listed.<br>\n";
   print "Choose the category below you wish to edit.<br>\n";
	print "<b>NOTE: SPACES ARE NOT ALLOWED, AND WILL BE REMOVED AUTOMATICALLY!</b><br>\n";
   print "<hr>\n";
   print "<center>\n";
   print "<form method=\"POST\" action=\"$cgi_url\">\n";
	print "<input type=\"hidden\" name=\"action\" value=\"editcat\">\n";
	print "Username: <input type=text name=\"username\"> -- \n";
	print "Password: <input type=password name=\"password\">\n";
   print "<table border>\n";
   print "<tr>\n"; 
   print "<th>Edit</th><th>Category</th>\n";   

	if(!open(CAT,"$basedir/$catfile")) {
		print "Can't Open Catalog File(2) - Cause: $!";
		exit;
	}
   @lines = <CAT>;
   close(CAT);

	$t = 1;
	foreach $cat(@lines) {	
      print "<tr>\n";
      print "<td align=center><input type=radio name=\"lineno\" value=\"$t\"></td><td align=center>$cat</td>\n";
      print "</tr>\n";
		$t++;
 	}
   print "</table>\n";
   print "<center><p>\n";
   print "<input type=submit value=\"Edit\"> <input type=reset>\n";
   print "</form>\n";
	print "<p><a href=\"$cgi_url\">RETURN</a>\n";
	print "&nbsp;&nbsp<a href=\"$cgi_url?category\">REFRESH</a>\n";
   print "</body></html>\n";
}


# THE DELETE ROUTINE!

elsif ($FORM{'action'} eq 'remove') {
	&check_passwd;
	# Open $linkdb file and place data into @lines array
	if(!open(DB,"$basedir/$linkdb")) {
		print "Can't Open LinkDB(3) - Cause: $!";
		exit;
	}
	@lines = <DB>;
	close(DB);

	# Open temp file.
	if(!open(TMP1,">>$basedir/$TMP1")) {
		print "Can't Open $TMP1 - Cause: $!";
		exit;
	}
	if(!open(TMP2,">>$basedir/$TMP2")) {
		print "Can't Open $TMP2 - Cause: $!";
		exit;
	}

	$y = 0;
	# Process each line
	foreach $line(@lines) {
		($section,$site,$url,$desc) = (split(/\|\|/,$line));
		$x = (split(/,/,$FORM{'lineno'}));
		(@lineno) = split(/,/,$FORM{'lineno'});
		if (@lineno[$y] eq $url) {
			print TMP1 $line;
			print "Removing: $section - $site - $url - $desc<br>\n";

			# Update Log File
			if(!open(LOG,">>$basedir/$logfile")) {
				print "Can't Open Log File - Cause: $!";
				exit;
			}
			print LOG "REMOVED BY FL_ADMIN: $url - $site -$desc";
			print LOG "==========================================\n";
			close(LOG);
			$y++;
		}
		else {
			print TMP2 $line;
		}
	}
	close(TMP1);
	close(TMP2);

	# Rename .temp2 to linkdb
   if(!rename("$basedir/$TMP2","$basedir/$linkdb")) {
		print "Error Renaming File! Cause: $!";
	}

	# Delete TMP1 file.
	unlink("$basedir/$TMP1");

	# Put return link onto page.
	print "<p><a href=\"$cgi_url\">RETURN TO MAIN MENU</a>\n";
	print "<p><a href=\"$cgi_url?delete\">BACK</a>\n";
	exit;

}

elsif ($FORM{'action'} eq 'editcat') {
	&check_passwd;
	# Open $catfile and place data into @lines array
	if(!open(CAT,"$basedir/$catfile")) {
		print "Can't Open Catalog File(3) - Cause: $!";
		exit;
	}
	@lines = <CAT>;
	close(CAT);

	print "<FORM method=POST action=\"$cgi_url\">\n";
	print "<input type=hidden name=action value=\"process\">\n";
	$u = 0;
	foreach $line(@lines) {
		$u++;
		if ($u eq $FORM{'lineno'}) {
			chop($line);
			print "Old Category: $line<br>\n";
			print "New Category: <input type=text name=newcat size=20><br>\n";
			print "<b>NOTE: LEAVE <i>New Category</i> Blank If You Wish To Delete $line</b><br>\n";
			print "<b>REMEMBER NO SPACES ALLOWD!</b><br>\n";
			print "<input type=hidden name=\"oldline\" value=\"$line\">\n";
		}
	}
	print "<input type=submit value=\" Process \">\n";
	print "</FORM>\n";
	print "<a href=\"$cgi_url\">RETURN TO MAIN MENU</a>\n";
	exit;
}


elsif ($command eq 'addcat') {
	# Open $catfile and place data into @lines array
	if(!open(CAT,"$basedir/$catfile")) {
		print "Can't Open Catalog File(4) - Cause: $!";
		exit;
	}
	@lines = <CAT>;
	close(CAT);

	print "<FORM method=POST action=\"$cgi_url\">\n";
	print "<input type=hidden name=action value=\"add\">\n";
	print "Username: <input type=text name=\"username\"> -- \n";
	print "Password: <input type=password name=\"password\"><p>\n";
	print "New Category: <input type=text name=newcat size=20><br>\n";
	print "<b>REMEMBER NO SPACES ALLOWD!</b><br>\n";
	print "<input type=submit value=\" Add Category \">\n";
	print "</FORM>\n";
	print "<a href=\"$cgi_url\">RETURN TO MAIN MENU</a>\n";
	exit;
}


elsif ($FORM{'action'} eq 'process') {
	if($FORM{'newcat'} eq $FORM{'oldline'}) {
		print "No Changes Made!<br>\n";
		print "Done - <a href=\"$cgi_url\">RETURN</a>\n";
		exit;
	}
	# Open $catfile and place data into @lines array
	if(!open(CAT,"$basedir/$catfile")) {
		print "Can't Open Catalog File(3) - Cause: $!";
		exit;
	}
	@lines = <CAT>;
	close(CAT);

	if(!open(TMP1,">>$basedir/$TMP1")) {
		print "Can't Open $TMP1 - Cause: $!";
		exit;
	}

	$remove = 0;
	foreach $line(@lines) {
		chop($line);
		if ($line eq $FORM{'oldline'}) {
			$newcat = $FORM{'newcat'};
			if ($newcat eq "") {
				$remove = 1;
				print "Removing - $FORM{'oldline'}<br>\n";
				print "<b>NOTE: Any Links That Still Exist Once A Category Has Been Deleted, Will No Longer Show Up!</b><br>\n";
			}
			if(!$remove) {
				$newcat =~ (s/\s+/_/g);
				print "<b>Changing:</b> $FORM{'oldline'} <b>To:</b> $newcat<br>\n";
				print TMP1 "$newcat\n";
			}
		}
		else {
			print TMP1 "$line\n" unless ($line eq $FORM{'oldline'});
		}
	}
	close(TMP1);
   if(!rename("$basedir/$TMP1","$basedir/$catfile")) {
		print "Error Renaming Catalog File! Cause: $!";
	}
	print "Done - <a href=\"$cgi_url\">RETURN</a>\n";
	exit;
}

elsif($FORM{'action'} eq 'add') {
	&check_passwd;
	if(!open(CAT,">>$basedir/$catfile")) {
		print "Can't Open Catalog File(3) - Cause: $!";
		exit;
	}
	$newcat = $FORM{'newcat'};
	$newcat =~ (s/\s+/_/g);
	print "Adding $newcat To Categories File!<br>\n";
	print CAT "$newcat\n";
	close(CAT);
	print "Done - <a href=\"$cgi_url\">RETURN</a>\n";
	exit;
}

# THE MAIN MENU!

else {
   print "<html><head><title>FreeLink Admin</title></head>\n";
   print "<body><center><h1>FreeLink Admin</h1>\n";
	print "<h6>By The Puppet Master</h6>\n";
   print "<hr></center>\n";
	print "<ul>\n";
	print "<li><a href=\"$cgi_url?delete\">Delete Link Entry</a></li>\n";
	print "<li><a href=\"$cgi_url?category\">Edit/Delete Categories</a></li>\n";
	print "<li><a href=\"$cgi_url?addcat\">Add A Category</a></li>\n";
	print "</ul>\n";
	print "<center>\n";
	print "<font size=\"-1\">FreeLink Admin \&copy; Copyright The Puppet Master<br>\n";
	print "</font></center>\n";
	print "</body></html>\n";
}

# DISPLAY THIS IF ANY DATA FILES ARE EMPTY!

sub no_data {
   print "<html><head><title>FreeLink Admin</title></head>\n";
   print "<body><center><h1>FreeLink Admin</h1>\n";
   print "<hr>\n";
   print "<body><center><h3>DATA FILE EMPTY!</h3>\n";
	print "<p><a href=\"$cgi_url\">RETURN</a>\n";
	exit;
}


sub check_passwd {
   if (!($FORM{'password'} eq $password && $FORM{'username'} eq $username)) {
		print "Invalid Username Or Password Was Entered!";
      exit;
   }
}

# END OF FL_ADMIN.PL
# COPYRIGHT 1999 THE PUPPET MASTER
