#!/usr/bin/perl
##############################################################################
# Program: FreeLink.pl
# Author: The Puppet Master <pmaster@ravensclaw.com>
# Created: 2/12/1999
# Purpose: A Free For All Links Script
# 
# Copyright (C) 1999 The Puppet Master
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# http://www.gnu.org/copyleft/gpl.html
# 
# NOTE: The above information MAY NOT be removed under any circumstances.
#
#############################################################################
# SYSTEM CONFIGURATION #

# $basedir is the system path to the freelink directory where all freelink 
# files are kept.
$basedir = '/home/pmaster/public_html/freelink';

# $title is the title of your link page.
$title = "FreeLinks By The Puppet Master";

# $cgi_url is the url location of this script.
$cgi_url = "http://www.ravensclaw.com/~pmaster/cgi-bin/freelink.cgi";

# $cat_file is the location and name of the categories file.
$cat_file = "sections.txt";

# $secfile is the location of the security number file used to prevent flooding
$secfile = "secnum.txt";

# $denyfile is the location of the deny log file
$denyfile = "denyfile.txt";

# Location and name of the link database.
$linkdb = "linkdb";

# Location and name of the log file.
$logfile = "log.txt";

# Email address of the administrator (That's You!)
$sysmail = "pmaster@ravensclaw.com";

# SMTP SERVER is the name of your servers SMTP server (ask your ISP)
$SMTP_SERVER = "chuck.ravensclaw.com";

# $use_frames: set it to 1 if you are using this script inside of a frame, or 
# 0 if you are not.
$use_frames = 0;

# IF $use_frames is 1, enter the name of the frame displaying output.
$frame_name = "Main";

# COLOR CONFIGURATIONS #

# $cat_color is the font color to use for the catalog heading
$cat_color = "RED";

# $bkcolor is the color of the background.
$bkcolor = "WHITE";

# $text_color is the color of the text.
$text_color = "BLACK";

# $link_color is the color of the link.
$link_color = "BLUE";

# $vlink_color is the color of the visited link.
$vlink_color = "PURPLE";

# $alink_color is the color of the active link.
$alink_color = "TEAL";

# $title_color is the color of the title.
$title_color = "ORANGE";

# YOU ARE DONE WITH MODIFICATINONS TO THE SCRIPT #

#############################################################################
# DO NOT MODIFY ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING!
#############################################################################

# Parse Form, Sendmail & Chkemail 
# Are Copyrighted by Matt Wright & Craig Patchett.

require 'parsform.pl';    # Parse the form
require 'sendmail.pl';    # Send Mail 
require 'chkemail.pl';    # Check for valid email address

# Badword.cgi Copyright 1999 The Puppet Master
require 'badword.cgi';     # Check for Naughty Language!


# Get ENV String and parse it.
if ($ENV{'QUERY_STRING'} ne '') {
   $command = "$ENV{'QUERY_STRING'}";
}
else {
	&parse_form;
}

# Print The Header.
print "Content-type: text/html\n\n";
print "<html><head><title>$title</title></head>\n";
print "<body bgcolor=\"$bkcolor\" text=\"$text_color\" link=\"$link_color\" vlink=\"$vlink_color\" alink=\"$alink_color\">\n";

if ($command eq 'addlink') {
	&secnum;
	if(!open(CAT,"$basedir/$cat_file")) {
		print "Can't Open Catalog File(1) - Cause: $!";
		exit;
	}
	@SECTION = <CAT>;
	close(CAT);

	$addr = $ENV{'REMOTE_ADDR'};

	print "<center><h3><font color=\"$title_color\">$title</font></h3><p>\n";
	print "<table border=1><tr><td>\n";
	print "<table border=0><tr>\n";
	print "<form method=\"POST\" action=\"$cgi_url\">\n";
	print "<input type=hidden name=\"action\" value=\"process\">\n";
	print "<input type=hidden name=\"secnum\" value=\"$secnum\">\n";
	print "<td>Site Name:</td><td><input type=text name=\"site\" size=30></td></tr>\n";
	print "<tr><td>Site URL:</td><td><input type=text name=\"url\" value=\"http://\" size=40></td></tr>\n";
	print "<tr><td>Description (50 Char.):</td><td><input type=text name=\"desc\" size=50></td></tr>\n";
	print "<tr><td>Category:</td><td><select name=section>\n";
	foreach $section(@SECTION) {
		chop($section);
		print "<option value=$section>$section\n";
	}
	print "</select></td></tr>\n";
	print "<tr><td>*Your Name:</td><td><input type=text name=\"name\" size=30></td></tr>\n";
	print "<tr><td>*Email Address:</td><td><input type=text name=\"email\" size=30></td></tr>\n";
	print "</table><center>* Your Name & Email Address Are For Our Records Only<br>Your IP Address: $addr</center></table>\n";
	print "<p><input type=submit value=\" Process \"> <input type=reset value=\" Clear \">\n";
	print "</form>\n";
	if ($use_frames eq '1') {
		print "<a href=\"$cgi_url\" target=\"$frame_name\">Back</a> To Links Page\n";
	}
	else {
		print "<a href=\"$cgi_url\">Back</a> To Links Page\n";
	}
	print "</body></html>\n";
	exit;
}

elsif ($FORM{'action'} eq 'process') {
	
	# Check the secnum file to prevent flooders
	&check_secnum;

	$addr = $ENV{'REMOTE_ADDR'};

	if ($valid eq "0") {
		&deny;
	}

	# Check for missing fields
	&missing unless $FORM{'site'};
	&missing unless $FORM{'url'};
	&missing unless $FORM{'name'};
	&missing unless $FORM{'email'};

	# Check fields for bad words!
	$word = $FORM{'site'};   # SITE
	&badword($word); 
	if ($badword eq "1") {
		&naughtyword;
	}
	$word = $FORM{'url'};    # URL
	&badword($word); 
	if ($badword eq "1") {
		&naughtyword;
	}
	$word = $FORM{'desc'};    # Description
	&badword($word); 
	if ($badword eq "1") {
		&naughtyword;
	}

	# Check Email address for validity.
	if(!&email_check($FORM{'email'})) {
		&bademail;
	}

	# Check For Duplicates
	if(-e "$basedir/$linkdb") {
		open(DB,"$basedir/$linkdb") || die "Can't Open Database - Cause: Empty!";
		@LINK = <DB>;
		close(DB);
		foreach $link(@LINK) {
			($lineno,$section,$site,$url,$desc) = (split(/\|\|/,$link));
			if ($site eq $FORM{'site'} || $url eq $FORM{'url'}) {
				&duplicate;
			}
		}
	}

	# Add Entry To Log File
	&log;

	# Add to database.
	if(!open(DB,">>$basedir/$linkdb")) {
		print "Can't Open LinkDB(1) - Cause: $!";
		exit;
	}
	print DB "$FORM{'section'}||$FORM{'site'}||$FORM{'url'}||$FORM{'desc'}\n";
	close(DB);

	# Send Mail to SysAdmin 
	$SUBJECT = "Addition To FreeLinks Page";
	$CC = "";
	$BCC = "";
	$BODY = "Name: $FORM{'name'}\nEmail: $FORM{'email'}\nURL: $FORM{'url'}\nSite: $FORM{'site'}\nDescription: $FORM{'desc'}\nCategory: $FORM{'section'}\nADDR: $addr";

	&send_email($SUBJECT,$FORM{'email'},$sysmail,$CC,$BCC,$BODY);
}

# Display link html file.
#open(DB,"$basedir/$linkdb") || die "Can't Open Database - For Reading";
if(!open(DB,"$basedir/$linkdb")) {
	print "Can't Open LinkDB(2) - Cause: $!";
	exit;
}
@LINK = <DB>;
close(DB);
$count = 0;
foreach $link(@LINK) {
	$count++;
	($lineno,$section,$site,$url,$desc) = (split(/\|\|/,$link));
}

#open(CATEGORY,"$basedir/$cat_file") || die "Can't Open Catalog File";
if(!open(CATEGORY,"$basedir/$cat_file")) {
	print "Can't Open Category(2) - Cause: $!";
	exit;
}
@CAT = <CATEGORY>;
close(CATEGORY);

print "<center><h3><font color=\"$title_color\">$title</font></h3></center><p>\n";
if ($use_frames eq '1') {
	print "There Are $count Links On This Page!<br><a href=\"$cgi_url?addlink\" target=\"$frame_name\">Add</a> A Link<p><hr>\n";
}
else {
	print "There Are $count Links On This Page!<br><a href=\"$cgi_url?addlink\">Add</a> A Link<p><hr>\n";
}
foreach $category(@CAT) {
	chop($category);
	print "<b><font color=\"$cat_color\">$category</font></b><p>\n";
	foreach $link(@LINK) {
		($section,$site,$url,$desc) = (split(/\|\|/,$link));
		print "<ul>\n";
		if ($section eq $category) {
			if ($use_frames eq '1') {
				print "<li><a href=\"$url\" target=\"_top\">$site</a> - $desc</li>\n";
			}
			else {
				print "<li><a href=\"$url\">$site</a> - $desc</li>\n";
			}
				
		}
		print "</ul>\n";
	}
	print "<hr>\n";
}
print "<font size=-1>FreeLink.PL &copy; Copyright 1999 The Puppet Master</font>\n";
exit;


sub bademail {
	print "<center><h2>Invalid Email Address</h2>\n";
	print "<font size=3 face=arial>The Email Address: $FORM{'email'} Is Of An Invalid Format.<p>\n";
	print "Please Use Your Browsers Back Button And Try Again!</font></center>\n";
	exit;
}


sub naughtyword {
	print "<center><h2>You Should Be Ashamed Of Your Self!</h2></center>\n";
	print "<font size=3 face=arial>Language Like That Is Not Allowed Here!</font></center>\n";
	exit;
}


sub missing {
	print "<center><h2>Missing Fields</h2></center>\n";
	print "The Following Fields Are Required Before Your Site Can Be Submitted:<ul>\n";
	print "<li>Site Name</li><li>Site URL</li><li>Your Name</li><li>Your Email Address</li></ul>\n";
	print "<p><center><font size=3 face=arial>Please Use Your Browsers Back Button And Try Again!</font></center>\n";
	exit;
}


sub duplicate {
	print "<center><h2>Duplicate Entry</h2>\n";
	print "<font size=3 face=arial>That Site/URL Already Exists.</font></center>\n";
	exit;
}


# Add to logfile
sub log {
	if(!open(LOG,">>$basedir/$logfile")) {
		print "Can't Open Log File - Cause: $!";
	}
	print LOG "SITE: $FORM{'site'}\n";
	print LOG "URL: $FORM{'url'}\n";
	print LOG "DESC: $FORM{'desc'}\n";
	print LOG "CATEGORY: $FORM{'section'}\n";
	print LOG "NAME: $FORM{'name'}\n";
	print LOG "EMAIL: $FORM{'email'}\n";
	print LOG "ADDR: $addr\n";
	print LOG "================================================\n";
	close(LOG);
}



sub secnum {
	srand(time ^ $$);
	$secnum = rand(time);
	if(!open(SECNUM,">$basedir/$secfile")) {
		print "Can't Open SECNUM File(1) - Cause: $!";
		exit;
	}
	print SECNUM "$secnum";
	close(SECNUM);
}



sub check_secnum {
	$valid = "0";
	if(!open(SECNUM,"$basedir/$secfile")) {
		print "Can't Open SECNUM File(2) - Cause: $!";
		exit;
	}
	$num = <SECNUM>;
	close(SECNUM);
	if($num eq $FORM{'secnum'}) {
		$valid = "1";
	}
}


sub deny {
	if(!open(DENY,">>$basedir/$denyfile")) {
		print "Can't Open Deny File - Cause: $!";
		exit;
	}
	print DENY "SITE: $FORM{'site'}\n";
	print DENY "URL: $FORM{'url'}\n";
	print DENY "DESC: $FORM{'desc'}\n";
	print DENY "CATEGORY: $FORM{'section'}\n";
	print DENY "NAME: $FORM{'name'}\n";
	print DENY "EMAIL: $FORM{'email'}\n";
	print DENY "REMOTE_ADDR: $addr\n";
	print DENY "=================================================\n";
	close(DENY);
	if ($use_frames eq '1') {
		print "<a href=\"$cgi_url\" target=\"$frame_name\">Flooding Not Allowed!</a>\n";
	}
	else{
		print "<a href=\"$cgi_url\">Flooding Not Allowed!</a>\n";
	}
	exit;
}
